﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
namespace WindowsFormsApplication8
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
    
            this.ultraGrid1.InitializeGroupByRow+=new Infragistics.Win.UltraWinGrid.InitializeGroupByRowEventHandler(ultraGrid1_InitializeGroupByRow);
            this.ultraGrid1.DisplayLayout.Override.HeaderPlacement = HeaderPlacement.OncePerGroupedRowIsland;
            this.ultraGrid1.DisplayLayout.Override.AllowColSizing = AllowColSizing.Free;
        }

       

     

        void ultraGrid1_InitializeGroupByRow(object sender, Infragistics.Win.UltraWinGrid.InitializeGroupByRowEventArgs e)
        {

             if (e.Row.Value != DBNull.Value)
                    e.Row.Hidden = true;

        }


        private DataTable GetTable()
        {
            DataTable table = new DataTable("Table");
            table.Columns.Add("ID", typeof(int));
            table.Columns.Add("Name", typeof(String));
            table.Columns.Add("ParentID", typeof(int));
            table.Columns.Add("Description", typeof(String));
 

            DataRow row = table.NewRow();
            row["ID"] = 1;
            row["Name"] = "Banks";
            row["ParentID"] = DBNull.Value;
            row["Description"] = "All Banks";
 
            table.Rows.Add(row);

            row = table.NewRow();
            row["ID"] = 2;
            row["Name"] = "CityBanks";
            row["ParentID"] = 1;
            row["Description"] = "City Banks";
        
            table.Rows.Add(row);

            row = table.NewRow();
            row["ID"] = 3;
            row["Name"] = "Checking";
            row["ParentID"] = 2;
            row["Description"] = "Checking Accounts";
 
            table.Rows.Add(row);

            row = table.NewRow();
            row["ID"] = 4;
            row["Name"] = "Checking1";
            row["ParentID"] = 3;
            row["Description"] = "Checking Account 1";
   
            table.Rows.Add(row);


            row = table.NewRow();
            row["ID"] = 5;
            row["Name"] = "Checking2";
            row["ParentID"] = 3;
            row["Description"] = "Checking Account 12";
 
            table.Rows.Add(row);

            row = table.NewRow();
            row["ID"] = 6;
            row["Name"] = "Assets";
            row["ParentID"] = DBNull.Value;
            row["Description"] = "All Assets";

            table.Rows.Add(row);
            return table;
        }


        private void button2_Click(object sender, EventArgs e)
        {
            DataSet data = new DataSet();
            data.Merge(this.GetTable()); 
            DataRelation r1 = new DataRelation("R1", data.Tables[0].Columns["ID"], data.Tables[0].Columns["ParentID"]);
            data.Relations.Add(r1);

            this.ultraGrid1.DataSource = data;
            this.ultraGrid1.DisplayLayout.ViewStyleBand = ViewStyleBand.OutlookGroupBy;
            this.ultraGrid1.DisplayLayout.ViewStyle = ViewStyle.MultiBand;
            this.ultraGrid1.DisplayLayout.Bands[0].SortedColumns.Add("ParentID", false, true);

            for (int i = 0; i < this.ultraGrid1.DisplayLayout.Bands.Count; i++)
            {
              
                this.ultraGrid1.DisplayLayout.Bands[i].Columns["ID"].Hidden = true;
                this.ultraGrid1.DisplayLayout.Bands[i].Columns["ParentID"].Hidden = true;
                this.ultraGrid1.DisplayLayout.Bands[i].Columns["Name"].Width = 10;
            }

            this.ultraGrid1.DisplayLayout.GroupByBox.Hidden = true;
         
             
             this.ultraGrid1.DisplayLayout.Rows.ExpandAll(true);
             foreach (UltraGridBand band in this.ultraGrid1.DisplayLayout.Bands)
             {
                 foreach (UltraGridColumn col in band.Columns)
                 {
                     col.PerformAutoResize(PerformAutoSizeType.AllRowsInBand, true); ;
                 }
             }
        }
 

    }
}
